"
 COPYRIGHT (c) 1989 by Claus Gittinger
	      All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"

Object subclass:#Workstation
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Interface-Graphics'
!

!Workstation class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 1989 by Claus Gittinger
	      All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
!

documentation
"
    this class is only here, to get an instance of XWorkstation
    named Display - this cannot be done in XWorkstation since Display
    is defined in X.h/Xlib.h -- sigh

    [author:]
	Claus Gittinger
"
! !

!Workstation class methodsFor:'initialization'!

initialize
    |wsClass workstationType altWorkstationType|

    "
     initialize the default display - this must be done only once
    "
    Display isNil ifTrue:[
	"
	 figure out, which display class to use
	 (if multiple have been bound into the system)
	"

	"
	 if there is a GL-XWorkstation, use it
	"
	(wsClass := Smalltalk at:#OpenGLWorkstation) notNil ifTrue:[
	    workstationType := wsClass.
	] ifFalse:[
	    (wsClass := Smalltalk at:#GLXWorkstation) notNil ifTrue:[
		workstationType := wsClass.
	    ] ifFalse:[
		workstationType := XWorkstation
	    ]
	].

	workstationType notNil ifTrue:[
	    "
	     make sure its initialized ...
	    "
	    workstationType initialize.
	].

	"
	 preparation for NeXTStep interfacing;
	 But if X is linked in and it capable of setting up a connection,
	 that will be used.
	"
	(wsClass := Smalltalk at:#NeXTWorkstation) notNil ifTrue:[
	    wsClass initialize.

	    workstationType isNil ifTrue:[
		workstationType := wsClass
	    ] ifFalse:[
		altWorkstationType := wsClass
	    ]
	].

	"
	 preparation for OS2 interfacing;
	 But if X is linked in and it capable of setting up a connection,
	 that will be used.
	"
	(wsClass := Smalltalk at:#OS2Workstation) notNil ifTrue:[
	    wsClass initialize.

	    workstationType isNil ifTrue:[
		workstationType := wsClass
	    ] ifFalse:[
		altWorkstationType := wsClass
	    ]
	].

	"
	 preparation for MAC interfacing;
	 But if X is linked in and it capable of setting up a connection,
	 that will be used.
	"
	(wsClass := Smalltalk at:#MacWorkstation) notNil ifTrue:[
	    wsClass initialize.

	    workstationType isNil ifTrue:[
		workstationType := wsClass
	    ] ifFalse:[
		altWorkstationType := wsClass
	    ]
	].

	"
	 Win32 interfacing;
	 But if X is linked in and it capable of setting up a connection,
	 that will be used.
	"
	(wsClass := Smalltalk at:#WinWorkstation) notNil ifTrue:[
	    wsClass initialize.

	    workstationType isNil ifTrue:[
		workstationType := wsClass
	    ] ifFalse:[
		altWorkstationType := wsClass
	    ]
	].

	workstationType notNil ifTrue:[
	    Display isNil ifTrue:[
		Display := workstationType basicNew initializeFor:nil.
	    ]
	] ifFalse:[
	    'Workstation [warning]: no concrete Display class built in' infoPrintCR.
	].

	"/ try alternative, if that did not work.
	Display isNil ifTrue:[
	    altWorkstationType notNil ifTrue:[
		Display := altWorkstationType basicNew initializeFor:nil.
	    ]
	].

	"
	 if we found any display, make it the default.
	"
	Display notNil ifTrue:[
	    DeviceWorkstation default:Display.
	    DisplayRootView initialize.
	    Screen := Display class.
	]
    ]

    "Modified: 10.1.1997 / 15:12:33 / cg"
!

reinitialize
    "reinitialize after a snapin."

    "
     this code will eventually handle the case where we come up
     on another type of workstation. For now, images saved while running
     on X will not work properly on some other device.
    "
    Display notNil ifTrue:[
	Display reinitialize.
    ]
! !

!Workstation class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/libview/Attic/Workstat.st,v 1.24 1997-11-20 18:42:44 cg Exp $'
! !
Workstation initialize!
